# gallenbacher_dijkstraa.py
# Programm entsprechend der Algorithmusformulierung von Gallenbacher
from gallenbacher_graph import gallenbacherGraph

start='I'
ziel='O'

class prioSchlange():
    def __init__(self, initWeg):
        self.wege=[initWeg]
        
    def wegLaenge(self, weg):
        laenge=0
        for kante in weg:
            laenge+=kante[1]
        return laenge
            
    def fuegeEin(self, bisher, dazu):
        neuerWeg=[dazu]
        for kante in bisher:
            neuerWeg.append(kante)
        if len(self.wege)==0:
            self.wege=[neuerWeg]
            return
        # zunaechst muss getestet werden, ob der Ort schon enthalten ist.
        for weg in self.wege:
            if neuerWeg[0]==weg[0]:
                # es gibt schon einen Weg zum Knoten
                if self.wegLaenge(neuerWeg)>=self.wegLaenge(weg):
                    # dann ist nichts zu tun
                    return
                else:
                    # der alte Weg muss entfernt werden
                    self.wege.remove(weg)
        position=len(self.wege)
        for weg in self.wege:
            if self.wegLaenge(weg)>self.wegLaenge(neuerWeg):
                position=self.wege.index(weg)
                break
        self.wege.insert(position,neuerWeg)
        
        
    def ersterRaus(self):
        temp = self.wege[0]
        self.wege=self.wege[1:]
        return temp


def dijkstraa(rot, wege, nachfolgeKanten, ziel):
    if len(wege.wege)==0: return False
    aktuellerWeg=wege.ersterRaus()
    if ziel==aktuellerWeg[0][0]: return aktuellerWeg
    for kante in nachfolgeKanten:
        if not (kante[0] in rot):
            wege.fuegeEin(aktuellerWeg,kante)         
    rot.append(wege.wege[0][0][0])
    nachfolger=gallenbacherGraph[wege.wege[0][0][0]]
    return dijkstraa(rot, wege, nachfolger, ziel)



print( dijkstraa([start], prioSchlange([[start,0]]), gallenbacherGraph[start], ziel) )






